// QWnd.cpp: implementation of the CQWnd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "QWnd.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



QWND_BEGIN_MESSAGE_MAP(CQWnd,NULL)
	QWND_MESSAGE_MAP(WM_CREATE,CQWnd::OnCreate)
	QWND_MESSAGE_MAP(WM_CLOSE,CQWnd::OnClose)
	QWND_MESSAGE_MAP(WM_DESTROY,CQWnd::OnDestroy)
	QWND_MESSAGE_MAP(WM_NCDESTROY,CQWnd::OnNcDestroy)
QWND_END_MESSAGE_DEFAULT_MAP()

CQWnd::CQWnd(){
	m_hWnd=NULL;
}

CQWnd::~CQWnd(){
}

BOOL CQWnd::CreateEx(DWORD dwExStyle, LPCTSTR lpszClassName,LPCTSTR lpszWindowName,DWORD dwStyle,int x,int y,int cx,int cy,HWND ParentWnd,HMENU hMenu,HINSTANCE hInstance){
	CREATESTRUCT cs;
	//ڶռ(ǰthisָ)
	cs.lpCreateParams=(LPVOID)this;
	cs.hInstance=hInstance;
	cs.hMenu=hMenu;
	cs.hwndParent=ParentWnd;
	cs.cx=cx;
	cs.cy=cy;
	cs.x=x;
	cs.y=y;
	cs.style=dwStyle;
	cs.lpszName=lpszWindowName;
	cs.lpszClass=lpszClassName;
    cs.dwExStyle=dwExStyle;
	BOOL ret=PreCreateWindow(cs);
	assert(ret);
	m_hWnd=CreateWindowEx(cs.dwExStyle,cs.lpszClass,cs.lpszName,cs.style,cs.x,cs.y,cs.cx,cs.cy,cs.hwndParent,cs.hMenu,cs.hInstance,cs.lpCreateParams);
	if(NULL==m_hWnd)
		return FALSE;
	return TRUE;
}

BOOL CQWnd::PreCreateWindow(CREATESTRUCT& cs){
	//жϴǷѾע
	WNDCLASSEX wcex;
	wcex.cbSize=sizeof(WNDCLASSEX);
	if(GetClassInfoEx(cs.hInstance,cs.lpszClass,&wcex))
		return TRUE;
	//עֱӷ,δעעµĴ(ṹÿҪֵ)
	wcex.cbSize=sizeof(WNDCLASSEX);
	wcex.style=CS_HREDRAW|CS_VREDRAW;
	wcex.lpfnWndProc=CQWnd::WindowProc;
	wcex.cbClsExtra=0;
	wcex.cbWndExtra=0;
	wcex.hIcon=::LoadIcon(NULL,IDI_QUESTION);
	wcex.hIconSm=::LoadIcon(NULL,IDI_QUESTION);
	wcex.hCursor=::LoadCursor(NULL,IDC_CROSS);
	wcex.hbrBackground=(HBRUSH)::GetStockObject(WHITE_BRUSH);
	wcex.lpszMenuName=NULL;
	wcex.hInstance=cs.hInstance;
	wcex.lpszClassName=cs.lpszClass;
	return ::RegisterClassEx(&wcex);
}


LRESULT CALLBACK CQWnd::WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	if(WM_NCCREATE==uMsg){
		//ȡṹ,һηWM_NCCREATEϢSetWindowLong
		CREATESTRUCT* pCs=(CREATESTRUCT*)lParam;
		if(pCs){
			CQWnd* pWnd=(CQWnd*)pCs->lpCreateParams;
			if(pWnd){
				//״Ϊֵ
				pWnd->m_hWnd=hWnd;
				SetWindowLong(hWnd,GWL_USERDATA,(LONG)pWnd);
				return pWnd->DispatchWindowProc(uMsg,wParam,lParam);
			}
		}
	}else{
		//ȡϴSetWindowLong
		CQWnd* pWnd=(CQWnd*)GetWindowLong(hWnd,GWL_USERDATA);
		if(pWnd){
			return pWnd->DispatchWindowProc(uMsg,wParam,lParam);
		}
	}
	return ::DefWindowProc(hWnd,uMsg,wParam,lParam);
}

//ĬϢ
BOOL CQWnd::DefaultWindowProc(UINT uMsg,WPARAM wParam,LPARAM lParam){
	return ::DefWindowProc(m_hWnd,uMsg,wParam,lParam);
}

BOOL CQWnd::UpdateWindow(void){
	if(NULL!=m_hWnd)
		return ::UpdateWindow(m_hWnd);
	return FALSE;
}

BOOL CQWnd::ShowWindow(int nCmdShow){
	if(NULL!=m_hWnd)
		return ::ShowWindow(m_hWnd,nCmdShow);
	return FALSE;
}

BOOL CQWnd::DestoryWindow(){
	if(NULL!=m_hWnd)
		return ::DestroyWindow(m_hWnd);
	return FALSE;
}

BOOL CQWnd::Attach(HWND hWnd){
	if(hWnd!=NULL){
		m_hWnd=hWnd;
		return TRUE;
	}
	return FALSE;
}

BOOL CQWnd::Detach(void){
	m_hWnd=NULL;
	return TRUE;
}

CQWnd* CQWnd::GetWndFromHandle(HWND hWnd){
	if(NULL==hWnd)
		return NULL;
	return (CQWnd*)GetWindowLong(hWnd,GWL_USERDATA);
}

BOOL CQWnd::SetWindowText(LPCSTR lpString){
	return ::SetWindowText(m_hWnd,lpString);
}

BOOL CQWnd::SetMenu(HMENU hMenu){
	return ::SetMenu(m_hWnd,hMenu);
}

BOOL CQWnd::MoveWindow(int X, int Y, int nWidth, int nHeight, BOOL bRepaint){
	return ::MoveWindow(m_hWnd,X,Y,nWidth,nHeight,bRepaint);
}

BOOL CQWnd::EnableWindow(BOOL bEnable){
	return ::EnableWindow(m_hWnd,bEnable);
}

BOOL CQWnd::IsWindowVisible(){
	return ::IsWindowVisible(m_hWnd);
}

HRESULT CQWnd::OnCreate(UINT uMsg,WPARAM wParam, LPARAM lParam){
	return DefaultWindowProc(uMsg,wParam,lParam);
}

HRESULT CQWnd::OnClose(UINT uMsg,WPARAM wParam, LPARAM lParam){
	DestoryWindow();
	return 0;
}

HRESULT CQWnd::OnDestroy(UINT uMsg,WPARAM wParam, LPARAM lParam){
	::PostMessage(m_hWnd,WM_QUIT,0,0);
	return DefaultWindowProc(uMsg,wParam,lParam);
}

HRESULT CQWnd::OnNcDestroy(UINT uMsg,WPARAM wParam, LPARAM lParam){
	return DefaultWindowProc(uMsg,wParam,lParam);
}

WNDPROC GetSuperWndProcAddr(){
	return CQWnd::WindowProc;
}



















